<mat-sidenav-container>
  <mat-sidenav #mapSidenav mode="side" opened>
    <mat-form-field class="full-width">
      <input matInput placeholder="Bearing" [(ngModel)]="bearing" />
    </mat-form-field>

    <mat-form-field class="full-width">
      <input matInput placeholder="Distance" [(ngModel)]="distance" />
    </mat-form-field>
    <button mat-button (click)="getDestination()">Get Destination</button>
    <mat-accordion displayMode="default" [multi]="true" [hideToggle]="false">
      <mat-expansion-panel [hideToggle]="false">
        <mat-expansion-panel-header>Layers</mat-expansion-panel-header>
        <mat-nav-list *ngIf="mapLayers" dense>
          <mat-list-item *ngFor="let layer of mapLayers">
            <a mat-line>{{ layer.id | uppercase }}</a>
            <!-- <button mat-icon-button (click)="flyTo(metar)">
                 <mat-icon>gps_fixed</mat-icon>
               </button> -->
          </mat-list-item>
        </mat-nav-list>
      </mat-expansion-panel>
    </mat-accordion>
    <app-layers-menu></app-layers-menu>
    <h3 matSubheader>Metars</h3>
    <mat-nav-list *ngIf="metars">
      <mat-list-item
        *ngFor="let metar of metars.features"
        [ngClass]="metar.properties.fltcat"
      >
        <h3 matLine>
          <strong>{{ metar.properties.id }}</strong>
        </h3>
        <p matLine>
          <span> {{ metar.properties.site }} </span>
          <span> -- {{ metar.properties.distance | number: "1.0-0" }} </span>
        </p>
        <button mat-icon-button (click)="flyTo(metar)">
          <mat-icon>gps_fixed</mat-icon>
        </button>
      </mat-list-item>
    </mat-nav-list>
  </mat-sidenav>
  <!-- Body -->
  <mat-sidenav-content>
    <!-- Begin ngx-mapbox-gl mapInstance -->
    <mgl-map
      [style]="'mapbox://styles/mapbox/outdoors-v10'"
      [zoom]="zoom"
      [center]="center"
      [maxBounds]="maxBounds"
      [fitBounds]="fitBounds"
      [fitBoundsOptions]="{ padding: 200 }"
      [cursorStyle]="cursorStyle"
      (load)="onLoad($event)"
      (moveEnd)="moveend($event)"
    >
      <mgl-control position="top-left">
        <button mat-icon-button (click)="mapSidenav.toggle()">
          <mat-icon *ngIf="mapSidenav.opened" class="md-dark"
            >arrow_left</mat-icon
          >
          <mat-icon *ngIf="!mapSidenav.opened" class="md-dark"
            >arrow_right</mat-icon
          >
        </button>
      </mgl-control>

      <mgl-control *ngIf="mapStatusUpdate" position="top-left">
        <span>{{ mapStatusUpdate }}</span>
      </mgl-control>

      <mgl-control mglGeocoder> </mgl-control>

      <mgl-control
        mglGeolocate
        [positionOptions]="{
          enableHighAccuracy: false,
          fitBounds: { maxZoom: 7 }
        }"
        [trackUserLocation]="true"
        [showUserLocation]="true"
      >
      </mgl-control>

      <mgl-control mglNavigation> </mgl-control>

      <mgl-control mglScale position="bottom-right"> </mgl-control>

      <mgl-layer
        id="3d-buildings"
        source="composite"
        sourceLayer="building"
        [filter]="['==', 'extrude', 'true']"
        type="fill-extrusion"
        [minzoom]="15"
        [paint]="{
          'fill-extrusion-color': '#aaa',
          'fill-extrusion-height': [
            'interpolate',
            ['linear'],
            ['zoom'],
            15,
            0,
            15.05,
            ['get', 'height']
          ],
          'fill-extrusion-base': [
            'interpolate',
            ['linear'],
            ['zoom'],
            15,
            0,
            15.05,
            ['get', 'min_height']
          ],
          'fill-extrusion-opacity': 0.6
        }"
        [before]="labelLayerId"
      >
      </mgl-layer>

      <!-- Destination Marker -->
      <mgl-marker *ngIf="destination" [lngLat]="destination"> </mgl-marker>

      <!-- Radar Layer -->
      <mgl-raster-source
        id="radar"
        [tiles]="[
          'https://nowcoast.noaa.gov/arcgis/services/nowcoast/radar_meteo_imagery_nexrad_time/MapServer/WmsServer?bbox={bbox-epsg-3857}&service=WMS&request=GetMap&version=1.3.0&layers=1&styles=&format=image/png&transparent=true&height=256&width=256&crs=EPSG:3857'
        ]"
        [tileSize]="256"
      >
      </mgl-raster-source>
      <mgl-layer
        id="radar"
        type="raster"
        source="radar"
        [layout]="layouts.radar.layout"
        [before]="labelLayerId"
      >
      </mgl-layer>

      <!-- Metars Layer -->
      <mgl-geojson-source id="metars" [data]="metars"> </mgl-geojson-source>
      <mgl-layer
        id="metars"
        type="symbol"
        source="metars"
        [layout]="layouts.metars.layout"
        [filter]="layouts.metars.filter"
        [paint]="layouts.metars.paint"
        (click)="onClick($event)"
        (mouseEnter)="cursorStyle = 'pointer'"
        (mouseLeave)="cursorStyle = ''"
      >
      </mgl-layer>

      <mgl-geojson-source *ngIf="units" id="units" [data]="units">
      </mgl-geojson-source>
      <mgl-layer
        *ngIf="units"
        id="units"
        type="symbol"
        source="units"
        [layout]="layouts.units.layout"
        [paint]="layouts.units.paint"
        (click)="onClick($event)"
        (mouseEnter)="cursorStyle = 'pointer'"
        (mouseLeave)="cursorStyle = ''"
      >
      </mgl-layer>

      <mgl-popup
        *ngIf="selectedPoint"
        [lngLat]="selectedPoint.geometry?.coordinates"
      >
        <ng-container [ngSwitch]="selectedPoint.layer?.id">
          <ng-template [ngSwitchCase]="'units'">
            <mat-card>
              <mat-card-title-group>
                <mat-card-title>{{
                  selectedPoint.properties.unitNumber
                }}</mat-card-title>
                <mat-card-subtitle>{{
                  selectedPoint.properties.base
                }}</mat-card-subtitle>
              </mat-card-title-group>
              <mat-card-content> Unit info </mat-card-content>
            </mat-card>
          </ng-template>

          <ng-template [ngSwitchCase]="'metars'">
            <mat-card>
              <mat-card-title-group>
                <mat-card-title>{{
                  selectedPoint.properties.id
                }}</mat-card-title>
                <mat-card-subtitle>{{
                  selectedPoint.properties.site
                }}</mat-card-subtitle>
                <mat-card-subtitle>{{
                  selectedPoint.properties.obsTime | date: "medium"
                }}</mat-card-subtitle>
              </mat-card-title-group>
              <mat-card-content>
                {{ selectedPoint.properties.rawOb }}
                <span *ngIf="selectedPoint.properties.rawTaf">
                  <h4>TAF</h4>
                  {{ selectedPoint.properties.rawTaf }}
                </span>
              </mat-card-content>
            </mat-card>
          </ng-template>
        </ng-container>
      </mgl-popup>
    </mgl-map>
    <!-- End ngx-mapbox-gl mapInstance -->
  </mat-sidenav-content>
</mat-sidenav-container>
